#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "modules.h"
struct disc_info disc;
PidList pids;
pid_t pid;
pid_t waitstatus;
int com_loop(DCD *dcd)
{
    int ttrack=0;
    int etrack=0;
    int Q=0;
    char Buff[100];
    FILE *LOOP;
    if(atoi(dcd->arg))
     {
      	printf("Looping Track %d", atoi(dcd->arg));
	ttrack=atoi(dcd->arg);
     }
   if(atoi(dcd->param))
       {
	  etrack=atoi(dcd->param);
	  printf(" --> %d", etrack);
       }
   printf("\n");
   if((LOOP=fopen("/tmp/.demcdloop", "r")) == NULL)
     {
	Q=1;
     }
   if(Q!=1)
     {
   fgets(Buff, 100, LOOP);
      if(!strcasecmp(Buff, "on"))
     {
	fclose(LOOP);
     	printf("Already Looping\n");
	return 0;
     }
     fclose(LOOP);
     }
      pid=fork();
      switch(pid)
     {
      case -1:
	perror("unable to fork");
	break;
      case 0:
	break;
      case 1:
	wait (&waitstatus);
	_exit (EXIT_SUCCESS);
	break;
     }
    pids.pid=getpid();
   LOOP=fopen("/tmp/.demcdloop", "w");
   fprintf(LOOP, "on");
   fclose(LOOP);
   while(pid)
     {
	LOOP=fopen("/tmp/.demcdloop", "r");
	fgets(Buff, 100, LOOP);
	if(!strcasecmp(Buff, "off"))
	  {
	  fclose(LOOP);
	  return 0;
	  }
	else{
	  fclose(LOOP);
	}
	cd_stat (dcd->fd, &disc);
	if(ttrack==0)
	  {
	switch(disc.disc_mode)
	  {
	   case CDAUDIO_COMPLETED:
	   case CDAUDIO_NOSTATUS:
	     cd_play_track(dcd->fd, 1, disc.disc_total_tracks);
	     break;
	  }
	  }
	else
	  {
	     if(etrack == 0)
	       etrack=ttrack;
	     if((disc.disc_current_track < ttrack) || (disc.disc_current_track > etrack))
	       {
		 cd_play_track(dcd->fd, ttrack, etrack);
	       }
	             switch(disc.disc_mode)
	       {
		case CDAUDIO_COMPLETED:
		case CDAUDIO_NOSTATUS:
		         cd_play_track(dcd->fd, ttrack, etrack);
		               break;
	       }
	     
	  }
     }
return 0;
}
int com_loopf()
{
   FILE *LOOP;
   FILE *RAND;
   LOOP=fopen("/tmp/.demcdloop", "w");
   fprintf(LOOP, "off");
   fclose(LOOP);
   RAND=fopen("/tmp/.demcdrand", "w");
   fprintf(RAND, "off");
   fclose(RAND);
   usleep(1000);
   if(pids.pid > 1)
   kill(pids.pid, SIGQUIT);
   return 0;
}


int init_module()
{
      printf("Loop.so Loaded\n");
      numcoms(2); // tells how many commands were loading
      addhook("loop", com_loop, "loops tracks");
      addhook("loopoff", com_loopf, "shuts of loop");
}
int finish_mod()
{
   printf("Closing module cleanly\n");
   com_loopf();
}
